CREATE DATABASE projeto;
USE projeto;

CREATE TABLE produtos (
     id INT NOT NULL AUTO_INCREMENT,
     nome VARCHAR(50) NOT NULL,
     descricao VARCHAR(255) NOT NULL,
     preco FLOAT NOT NULL,
     ativo BOOL,
     PRIMARY KEY (id)
);

CREATE TABLE usuarios (
	id INT NOT NULL AUTO_INCREMENT,
    nome VARCHAR(100) NOT NULL,
	email VARCHAR(100) NOT NULL,
    telefone VARCHAR(20) NOT NULL,
    senha VARCHAR(255) NOT NULL,
    is_admin BOOL,
    ativo BOOL,
	PRIMARY KEY (id),
    UNIQUE (email)
);

INSERT INTO usuarios (nome, email, senha, telefone, is_admin, ativo)
 VALUES ("John Doe","admin@admin", "$2a$10$X4Fpl7B1YYKddb7Ob2UHHe2dZ21iVKhw9Hln2BUsSWybbzS3Q8wtC", "41995997536", TRUE, TRUE);
    
CREATE TABLE enderecos (
	id INT NOT NULL AUTO_INCREMENT,
    cep VARCHAR(8) NOT NULL,
	bairro VARCHAR(50) NOT NULL,
    cidade VARCHAR(50) NOT NULL,
    rua VARCHAR(100) NOT NULL,
    numero VARCHAR(10) NOT NULL,
    complemento VARCHAR(50),
    ativo BOOL,
	PRIMARY KEY (id)
);

CREATE TABLE endereco_usuario (
	endereco_id INT NOT NULL,
    usuario_id INT NOT NULL,
	FOREIGN KEY (endereco_id) REFERENCES enderecos(id),
    FOREIGN KEY (usuario_id) REFERENCES usuarios(id)
);

CREATE TABLE fornecedores (
	id INT NOT NULL AUTO_INCREMENT,
    nome VARCHAR(100) NOT NULL,
    telefone VARCHAR(20) NOT NULL,
    endereco_id INT NOT NULL,    
    ativo BOOL,
    PRIMARY KEY (id),
    FOREIGN KEY endereco_id_fk(endereco_id) REFERENCES enderecos(id) ON DELETE CASCADE
);

CREATE TABLE itens_estoque (
	produto_id INT NOT NULL,
    fornecedor_id INT NOT NULL,
	quantidade INT NOT NULL,
    FOREIGN KEY (produto_id) REFERENCES produtos(id),
    FOREIGN KEY (fornecedor_id) REFERENCES fornecedores(id),
    CONSTRAINT UNIQUE (produto_id, fornecedor_id)
);

CREATE TABLE pedidos (
	id INT NOT NULL AUTO_INCREMENT,
    date_time DATETIME,
    usuario_id INT NOT NULL,
    endereco_id INT NOT NULL,
    situacao varchar(50),
    PRIMARY KEY (id)
);

CREATE TABLE item_pedido (
	pedido_id INT NOT NULL,
    produto_id INT NOT NULL,
    fornecedor_id INT NOT NULL,
    valor_unitario DOUBLE NOT NULL,
    quantidade INT NOT NULL
);