package data;

import java.text.DecimalFormat;
import java.util.Date;
import java.util.List;

public class Pedido {
    private long id;
    private Date dateTime;
    private Usuario usuario;
    private Endereco endereco;
    private List<ItemPedido> itens;
    private String situacao;
    private double total;

    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    public Date getDateTime() {
        return dateTime;
    }

    public void setDateTime(Date dateTime) {
        this.dateTime = dateTime;
    }

    public Usuario getUsuario() {
        return usuario;
    }

    public void setUsuario(Usuario usuario) {
        this.usuario = usuario;
    }

    public Endereco getEndereco() {
        return endereco;
    }

    public void setEndereco(Endereco endereco) {
        this.endereco = endereco;
    }

    public List<ItemPedido> getItens() {
        return itens;
    }

    public void setItens(List<ItemPedido> itens) {
        this.itens = itens;
    }

    public String getSituacao() {
        return situacao;
    }

    public void setSituacao(String situacao) {
        this.situacao = situacao;
    }

    public double getTotal() {
        return total;
    }

    public void setTotal(double total) {
        this.total = total;
    }
    
    public static String listarItens(List<ItemPedido> resumo) {
        String lista = "<table style='border: 1px solid black;'><tr><th>Produto</th><th>Quantidade</th><th>Preço unitário</th><th>Total</th></tr>";
        double total = 0;                
        
        forPedido: for (ItemPedido ip : resumo) {  
            lista += "<tr>";
            lista += "<td>" + ip.getProduto().getNome() + "</td>";
            lista += "<td>" + ip.getQuantidade() + "</td>";
            lista += "<td>R$ " + new DecimalFormat("#.##").format(ip.getValorUnitario()) + "</td>";
            lista += "<td>R$ " + new DecimalFormat("#.##").format(ip.getQuantidade()*ip.getValorUnitario()) + "</td>";
            lista += "<tr>";
            total += ip.getQuantidade()*ip.getValorUnitario();
        }
        lista += "<tr><td>Total</td><td></td><td></td><td>R$ " + new DecimalFormat("#.##").format(total) + "</td></table>"; 
        
        return lista;
    }

    @Override
    public String toString() {
        return "Pedido{" + "id=" + id + ", dateTime=" + dateTime + ", usuario=" + usuario + ", endereco=" + endereco + ", itens=" + itens + ", situacao=" + situacao + ", total=" + total + '}';
    }
 
}
