package security;

import data.Usuario;
import java.security.Principal;
import javax.ws.rs.core.SecurityContext;

public class ContextoDeSeguranca implements SecurityContext {
    private final Usuario usuario;    
    private final String scheme;

    public ContextoDeSeguranca(Usuario usuario, String scheme) {
        this.usuario = usuario;
        this.scheme = scheme;
    }
    
    @Override
    public Principal getUserPrincipal() {
        return this.usuario;
    }

    @Override
    public boolean isUserInRole(String role) {
        return this.usuario.isAdmin();
    }

    @Override
    public boolean isSecure() {
        return "https".equals(this.scheme);
    }

    @Override
    public String getAuthenticationScheme() {
        return "JWT";
    }
    
}
