app = angular.module('app').controller('enderecoCtrl', function($http){
    var self = this;
    self.endereco = undefined;    
    self.enderecos = [];
    var viacepUrl = 'https://viacep.com.br/ws/';
    
    self.buscaCep = function(cep) {
        if (cep !== undefined) {
            if (cep.length === 8) {
                $http({
                    method: 'GET',
                    url: viacepUrl + cep + '/json/'
                }).then(function successCallback(response) {
                    if (response.data.erro) {
                        $('#tituloMensagem').text("Erro");
                        $('#corpoMensagem').text("CEP inválido");            
                        $('#mensagem').modal('show');
                    } else {                                 
                        self.endereco.bairro = response.data.bairro;
                        self.endereco.cidade = response.data.localidade;
                        self.endereco.rua = response.data.logradouro;
                    }
                }, function errorCallback(response) {
                    $('#tituloMensagem').text("Erro");
                    $('#corpoMensagem').text("Erro ao localizar CEP");            
                    $('#mensagem').modal('show');
                });
            } else {
                $('#tituloMensagem').text("Erro");
                $('#corpoMensagem').text("CEP inválido");            
                $('#mensagem').modal('show');
            }
        }        
    };

    self.novo = function() {
        self.endereco = {};
    };
    self.salvar = function() {
        if (self.endereco.id) {
            metodo = 'PUT';
        } else {
            metodo = 'POST';
        }
        $http({
            method: metodo,
            url: urlBase + 'usuario/secure/enderecos/',
            data: self.endereco,
            headers: { 'Authorization': 'Bearer ' + localStorage.getItem("token") }
        }).then(function successCallback(response) {
            self.updTab();
            self.endereco = undefined;
        }, function errorCallback(response) {
            console.log(response.data);
            $('#tituloMensagem').text("Erro");
            $('#corpoMensagem').text("Erro ao salvar endereço");            
            $('#mensagem').modal('show');
        });
    };
    self.alterar = function(endereco) {
        self.endereco = endereco;
    };
    self.confExcluirEnd = function(e) {
        self.excluirEndereco = e;
        $('#confExcluirEnd').modal('show');
    };
    self.excluir = function() {
        $http({
            method: 'DELETE',
            url: urlBase + 'usuario/secure/enderecos/' + self.excluirEndereco.id + '/',
            headers: { 'Authorization': 'Bearer ' + localStorage.getItem("token") }
        }).then(function successCallback(response) {
            self.endereco = undefined;
            self.updTab();
            $('#confExcluirEnd').modal('hide');
        }, function errorCallback(response) {
            $('#confExcluirEnd').modal('hide');
            console.log(response.data);
            $('#tituloMensagem').text("Erro");
            $('#corpoMensagem').text("Erro ao excluir o endereço");            
            $('#mensagem').modal('show');
        });
    };
    self.updTab = function() {
        $http({
            method: 'GET',
            url: urlBase + 'usuario/secure/enderecos/',
            headers: { 'Authorization': 'Bearer ' + localStorage.getItem("token") }
        }).then(function successCallback(response) {
            self.enderecos = response.data;
            self.endereco = undefined;
        }, function errorCallback(response) {
            console.log(response.data);
            $('#tituloMensagem').text("Erro");
            $('#corpoMensagem').text("Erro ao obter endereços");            
            $('#mensagem').modal('show');
        });                    
    };

    self.activate = function (){
        self.updTab();
    };
    self.activate();  
});

