app = angular.module('app').controller('loginCtrl', function($http, $location, $rootScope){
    var self = this;
    self.usuario = undefined;  
    self.loading = false;
    
    self.login = function() {        
        $http({
            method: 'POST',
            url: urlBase + 'login/',
            data: self.usuario
        }).then(function successCallback(response) {            
            self.usuario = response.data;            
            localStorage.setItem('token', response.data.token);
            var carrinho = JSON.parse(localStorage.getItem("carrinho"));
            if (carrinho === null) {
                $location.path("/");                
            } else {
                if (carrinho.length === 0) {
                    $location.path("/");                    
                } else {
                    $location.path("/carrinho");
                }                
            }            
        }, function errorCallback(response) {
            $('#tituloMensagem').text("Erro");
            $('#corpoMensagem').text("Usuário ou senha inválidos");
            $('#mensagem').modal('show');
        });
    };
    
    self.sair = function () {
        self.usuario = undefined;
        localStorage.removeItem("token");
    };
    
    self.confirmarAlterarSenha = function () {  
        self.loading = true;
        $http({
            method: 'POST',
            url: urlBase + 'login/resetSenha/',
            data: self.email
        }).then(function successCallback(response) {            
            self.esqueci = false;
            self.loading = false;
            $('#tituloMensagem').text("Sucesso");
            $('#corpoMensagem').text("Sua nova senha foi enviada para seu email");
            $('#mensagem').modal('show');            
        }, function errorCallback(response) {
            self.loading = false;
            $('#tituloMensagem').text("Erro");
            $('#corpoMensagem').text("Email não encontrado");
            $('#mensagem').modal('show');            
        });
    };
    
    self.activate = function (){        
        //set rest path
        urlBase = $location.protocol() + '://' + $location.host() + ':' + $location.port() + '/projeto/rest/';                

        if (self.usuario === undefined) {
            if (localStorage.getItem("token") !== null) {
                self.usuario = "loading user";
                $http({
                    method: 'GET',
                    url: urlBase + 'login/secure/',            
                    headers: { 'Authorization': 'Bearer ' + localStorage.getItem("token") }
                }).then(function successCallback(response) {
                    self.usuario = response.data;
                }, function errorCallback(response) {
                    self.usuario = undefined;
                    console.log("Token inválido");
                });
            }
        }        
    };
    
    self.activate(); 

    $rootScope.$on('$routeChangeSuccess', function (event, current, previous, rejection) {
        if (current.$$route.originalPath === "/" && self.usuario === undefined) {
            self.activate(); 
        }    
    });
});