app = angular.module('app').controller('produtoCtrl', function($http){
    var self = this;
    self.produto = undefined;   
    self.produtos = [];
    self.estoqueVazio = false;

    self.novo = function() {
        self.produto = {};
    };
    self.salvar = function() {
        if (self.produto.id) {
            metodo = 'PUT';
        } else {
            metodo = 'POST';
        }        
        $http({
            method: metodo,
            url: urlBase + 'produtos/secure/',
            data: self.produto,
            headers: { 'Authorization': 'Bearer ' + localStorage.getItem("token") }
        }).then(function successCallback(response) {
            self.updTab();
            self.produto = undefined;
        }, function errorCallback(response) {
            self.erro(response.status);
        });
    };
    self.alterar = function(produto) {
        self.produto = produto;
    };
    self.excluir = function(produto) {
        self.produto = produto;

        $http({
            method: 'DELETE',
            url: urlBase + 'produtos/secure/' + self.produto.id + '/',
            headers: { 'Authorization': 'Bearer ' + localStorage.getItem("token") }
        }).then(function successCallback(response) {
            self.produto = undefined;
            self.updTab();
        }, function errorCallback(response) {
            self.erro(response.status);
        });
    };
    
    function estoqueVazio(produtos) {        
        if (produtos.length === 0) {
            return false;
        }
        var vazio = true;
        Object.values(produtos).forEach(produto => {            
            if (produto.quantDisponivel > 0) {
                vazio = false;
                return false;
            }
        });
        return vazio;
    };
    
    self.updTab = function() {
        $http({
            method: 'GET',
            url: urlBase + 'produtos/'
        }).then(function successCallback(response) {            
            if (estoqueVazio(response.data)) {
                self.estoqueVazio = true;
            }
            self.produtos = response.data;
            self.produto = undefined;
        }, function errorCallback(response) {
            self.erro(response.status);
        });
    };
    self.erro = function(mensagem) {
        alert(mensagem);
    };

    self.activate = function (){
        self.updTab();
    };
    self.activate();  
});

app.directive('mascaraReal', ['$filter', function () {
    formatter = function (number) {        
        if (isNaN(number)) {
            if (number === undefined) {
                number = 0;
            } else {                                
                number = number.toString().replace(",",".");                
            }            
        }
        return Number(number).toLocaleString('pt-BR', { style: 'currency', currency: 'BRL', maximumFractionDigits: 2});        
    };

    return {
        restrict: 'A',
        require: 'ngModel',
        link: function (scope, element, attr, ngModel) {
            ngModel.$parsers.push(function (str) {
                return str ? str : '';
            });
            ngModel.$formatters.push(formatter);

            element.bind('blur', function() {
                element.val(formatter(ngModel.$modelValue));
            });
            element.bind('focus', function () {
                element.val(ngModel.$modelValue);
            });
        }
    };
}]);