var app = angular.module("app", ["ngRoute", "ui.mask"]);
var urlBase = '';


app.config(function($routeProvider) {
        $routeProvider
        .when("/", {
            templateUrl : "resources/app/views/inicio.html"
        })        
        .when("/produtos", {
            templateUrl : "resources/app/views/produtos.html"
        })
        .when("/origem", {
            templateUrl : "resources/app/views/origem.html"
        })
        .when("/login", {
            templateUrl : "resources/app/views/login.html"
        })
        .when("/cadastro", {
            templateUrl : "resources/app/views/cadastro.html"
        })  
        .when("/carrinho", {
            templateUrl : "resources/app/views/carrinho.html"
        })
        .when("/cliente", {
            templateUrl : "resources/app/views/cliente.html"
        })
        .when("/endereco", {
            templateUrl : "resources/app/views/endereco.html"
        })
        .when("/administrador", {
            templateUrl : "resources/app/views/administrador.html"
        });
});

app.filter('CEP', function() {
    return function(input) {
        var out = '';
        if (input !== undefined) {
            input = input.replace(/\D/g,"");
            if (input.length === 8) {
                out = input.substring(0,2) + "." + input.substring(2,5) + "-" + input.substring(5,8);
            }
        }                
        return out;
    };
});

app.filter('telefone', function() {
    return function(input) {
        var out = '';
        if (input !== undefined) {
            if (input !== null) {
                input = input.replace(/\D/g,"");
                if (input.length === 11) {
                    out = "(" + input.substring(0,2) + ") " + input.substring(2,7) + "-" + input.substring(7,11);
                } else if (input.length === 10) {
                    out = "(" + input.substring(0,2) + ") " + input.substring(2,6) + "-" + input.substring(6,10);
                }
            }            
        }                
        return out;
    };
});