app = angular.module('app').controller('cadastroCtrl', function($http, $location){
    var self = this;        
    self.mascaraTel = "(99) 9999-9999";
    var viacepUrl = 'https://viacep.com.br/ws/';
    
    self.buscaCep = function(cep) {
        if (cep !== undefined) {
            cep = cep.replace(/\D/g,"");            
            if (cep.length === 8) {
                $http({
                    method: 'GET',
                    url: viacepUrl + cep + '/json/'
                }).then(function successCallback(response) {
                    if (response.data.erro) {
                        $('#tituloMensagem').text("Erro");
                        $('#corpoMensagem').text("CEP inválido");            
                        $('#mensagem').modal('show');
                    } else {                                 
                        self.endereco.bairro = response.data.bairro;
                        self.endereco.cidade = response.data.localidade;
                        self.endereco.rua = response.data.logradouro;
                    }
                }, function errorCallback(response) {
                    $('#tituloMensagem').text("Erro");
                    $('#corpoMensagem').text("Erro ao localizar CEP");            
                    $('#mensagem').modal('show');
                });
            } else {
                $('#tituloMensagem').text("Erro");
                $('#corpoMensagem').text("CEP inválido");            
                $('#mensagem').modal('show');
            }
        }        
    };
    
    self.cadastrar = function (form) {
        if (form.$valid) {
            $http({
                method: 'PUT',
                url: urlBase + 'login/',
                data: self
            }).then(function successCallback(response) {            
                $http({
                    method: 'POST',
                    url: urlBase + 'login/',
                    data: self.usuario
                }).then(function successCallback(response) {                           
                    localStorage.setItem('token', response.data.token);
                    $location.path("/");
                }, function errorCallback(response) {
                    $('#tituloMensagem').text("Erro");
                    $('#corpoMensagem').text("Usuário já cadastrado");        
                    $('#mensagem').modal('show');
                });        
            }, function errorCallback(response) {
                $('#tituloMensagem').text("Erro");
                $('#corpoMensagem').text("Usuário já cadastrado");        
                $('#mensagem').modal('show');
            });
        }        
    };
});

app.directive('mascaraCep', ['$filter', function ($filter) {
    formatter = function (number) {
        return $filter('currency')(number);
    };

    return {
        restrict: 'A',
        require: 'ngModel',
        link: function (scope, element, attr, ngModel) {
            ngModel.$parsers.push(function (str) {
                return str ? Number(str) : '';
            });
            ngModel.$formatters.push(formatter);

            element.bind('blur', function() {
                element.val(formatter(ngModel.$modelValue));
            });
            element.bind('focus', function () {
                element.val(ngModel.$modelValue);
            });
        }
    };
}]);