app = angular.module('app').controller('usuarioCtrl', function($http){
    var self = this;
    self.pedidos;
    self.pedido = undefined;
    self.alterar = false;

    self.mostrarPedido = function(p){        
        $http({
            method: 'GET',
            url: urlBase + 'usuario/secure/pedido/' + p.id + '/',            
            headers: { 'Authorization': 'Bearer ' + localStorage.getItem("token") }
        }).then(function successCallback(response) {            
            var itens = [];
            var found;
            Object.values(response.data.itens).forEach(item => {
                found = -1;                                
                for (var i = 0; i < itens.length; i++) {                    
                    if (itens[i].produto.id === item.produto.id) {
                        itens[i].quantidade += item.quantidade;
                        return;
                    }
                }
                if (found === -1) {
                    itens.push(item);
                }
            });            
            self.pedido = response.data;
            self.pedido.itens = itens;
        }, function errorCallback(response) {
            console.log("Token inválido");
        });        
                
        $("#modalPedido").modal('show');
    };
    
    self.confirmarCancelarPedido = function() {
        $("#modalPedido").modal('hide');
        $('#modalConfirmarCancelarPedido').modal('show');
    };
    
    self.cancelarPedido = function() {          
        $('#modalConfirmarCancelarPedido').modal('hide');        
        if (self.pedido.situacao === "Novo") {
            $http({
                method: 'PUT',
                url: urlBase + 'usuario/secure/pedido/',
                data: self.pedido,
                headers: { 'Authorization': 'Bearer ' + localStorage.getItem("token") }
            }).then(function successCallback(response) {
                self.activate();
                $('#tituloMensagem').text("Sucesso");
                $('#corpoMensagem').text("Pedido cancelado com sucesso");                  
            }, function errorCallback(response) {
                $('#tituloMensagem').text("Erro");
                $('#corpoMensagem').text("Erro ao cancelar pedido");                    
                console.log("Token inválido");
            });        
        } else {
            $('#tituloMensagem').text("Erro");
            $('#corpoMensagem').text("Só é possível cancelar pedidos com Situação 'Novo'");                    
        }        
        $('#mensagem').modal('show');
    };
            
    self.confirmarAlterarSenha = function (usuario) {
        var data = new Object();
        data.usuario = usuario;
        data.senhaAtual = self.senhaAtual;
        data.senhaNova = self.senhaNova;
                
        $http({
            method: 'PUT',
            url: urlBase + 'usuario/secure/senha/',
            data: data,
            headers: { 'Authorization': 'Bearer ' + localStorage.getItem("token") }
        }).then(function successCallback(response) {
            self.activate();
            self.alterar = false;
            self.senhaAtual = "";
            self.senhaNova = "";
            $('#tituloMensagem').text("Sucesso");
            $('#corpoMensagem').text("Senha alterada com sucesso!");
            $('#mensagem').modal('show');
        }, function errorCallback(response) {
            $('#tituloMensagem').text("Erro");
            $('#corpoMensagem').text("Erro, senha atual não confere");            
            $('#mensagem').modal('show');
        });
    };
    
    self.activate = function (){                                                    
        $http({
            method: 'GET',
            url: urlBase + 'usuario/secure/pedidos/',            
            headers: { 'Authorization': 'Bearer ' + localStorage.getItem("token") }
        }).then(function successCallback(response) {
            self.pedidos = response.data;
        }, function errorCallback(response) {
            self.pedidos = undefined;
            console.log("Token inválido");
        });    
    };
    
    self.activate(); 
});